#!/bin/bash

if [ "$DEMIURGETP" = "" ]
then
   echo "The Environment variable DEMIURGETP is undefined."
   exit 1
fi

echo "Installing CUDD utilities ..."

CUDD="cudd-2.5.0"
CUDD_ARCHIVE="$CUDD.tar.gz"

if [ ! -e "$CUDD_ARCHIVE" ];
then
  echo " Downloading CUDD utilities ..."
  wget ftp://vlsi.colorado.edu/pub/$CUDD_ARCHIVE
fi

echo " Unpacking CUDD utilities ..."
rm -rf $DEMIURGETP/$CUDD
tar -xzf $CUDD_ARCHIVE -C $DEMIURGETP

echo " Compiling CUDD utilities ..."
(cd $DEMIURGETP/$CUDD; make)
