#!/bin/bash

echo "Installing psl2ba ..."

PSL2BA="psl2ba_2010-01-26"
PSL2BA_ARCHIVE="$PSL2BA.tar.gz"

if [ ! -e "$AIGER_ARCHIVE" ];
then
  echo " Downloading PSL2BA ..."
  wget https://psl2ba.googlecode.com/files/$PSL2BA_ARCHIVE
fi

echo " Unpacking PSL2BA ..."
rm -rf $PSL2BA
mkdir $PSL2BA
tar -xzf $PSL2BA_ARCHIVE -C $PSL2BA

echo " Compiling PSL2BA utilities ..."
(cd $PSL2BA/psl2ba;
sed -i.bak "s/val create : int -> ('a, 'b) t/val create : ?random:bool -> int -> ('a, 'b) t/" extlib-1.5/extHashtbl.mli;
sed -i.bak "s|cudd=./cudd-2.4.2|cudd=../../ocaml-cudd/cudd-2.5.0|" Makefile;
 make)
