type clock 
val clock : string -> int -> Speculog.declaration * clock Expr.t
val clock_to_int : clock Expr.t -> int Expr.t

type order = Less | LessEq | Eq | GreaterEq | Greater
val order_to_expr : order -> 'a Expr.t -> 'a Expr.t -> bool Expr.t
type guard = clock Expr.t * order * int Expr.t
(** The second argument is the time elapsed (to be added to the clocks). *)
val guard_to_expr : guard -> clock Expr.t -> bool Expr.t
val guards_to_expr : guard list -> clock Expr.t -> bool Expr.t

type location = {id : int; invariant : bool Expr.t }
type transition = {src : int; dst : int; guards : guard list; resets : (clock Expr.t) list }
type t =
  {
    declarations : Speculog.declaration list; 
    clocks: (clock Expr.t) list;
    locations: location list; 
    transitions: transition list;
    maxval : int
  }
