module Player = 
struct 
  type t = int
  let compare = compare
end


module Coalition = Set.Make(Player)

type t = Coalition.t
let empty = Coalition.empty
let singleton = Coalition.singleton
let add = Coalition.add
let fold = Coalition.fold
let elements = Coalition.elements
let diff = Coalition.diff
let cardinal = Coalition.cardinal
let is_empty = Coalition.is_empty
let choose = Coalition.choose
let remove = Coalition.remove

let to_string c = 
  Coalition.fold (fun x a -> Printf.sprintf "%s%d;" a x) c ""

let of_aiger aiger =
  List.fold_left
    (fun set name ->	
      match Str.split (Str.regexp "_") name with
      | "player" :: i :: _ -> add (int_of_string i) set
      | _ -> set
    ) empty (Aiger.inputs aiger) 
