(** Takes an aiger file and determinize it. 
    In the circuit given as argument there are:
    latches [l] to describe states of the automaton;
    inputs [i] of the automaton;
    for each of this latches [l] there is an input [NEXT_l];
    a output VALID that is true when a transition from the current state to the one described by the inputs exists;
    a latch INITIALIZED true after the first update.

    The outputs are set to true if one of the possible current state put it to true.

*)
val determinize : Aiger.t -> Aiger.t

(** Read an aiger file from the given file and write the determinized
    aiger to the standard output. *)
val test : string -> unit
