open ParametricModule

(* Defines an Adder of the size of the given parameter *)  
let adder i = 
  let buf = Buffer.create 100 in
  Buffer.add_string buf "
module ADD;
input a;
input b;
input c_in;
output s;
output c_out;
s = (a xor b) xor c_in;
c_out = (a & b) | (a& c_in) | (b & c_in) ;
endmodule
";
  Printf.bprintf buf "input [%d:0] a;\n" (i-1);
  Printf.bprintf buf "input [%d:0] b;\n" (i-1);
  Printf.bprintf buf "output [%d:0] s;\n" (i);
  (*Printf.bprintf buf "output [%d:0] s;\n" (i+1);*)
  (*Printf.bprintf buf "wire [%d:0] w;\n" (i-2);*)
  Printf.bprintf buf "_false=0;\n";
  Printf.bprintf buf "ADD(a=a<0>,b=b<0>,s=s<0>, c_in=_false, c_out=w<0>);\n";
  for j = 1 to (i-2) do
    Printf.bprintf buf "ADD(a=a<%d>,b=b<%d>,s=s<%d>, c_in=w<%d>, c_out=w<%d>);\n" j j j (j-1) j;
  done;
  Printf.bprintf buf "ADD(a=a<%d>,b=b<%d>,s=s<%d>, c_in=w<%d>, c_out=s<%d>);\n" (i-1) (i-1) (i-1) (i-2) (i);
  (*Printf.bprintf buf "s = sw;";*)

  parse (Buffer.contents buf)


let module_and size = 
  let buf = Buffer.create 100 in
  Printf.bprintf buf "input [%d:0] a;" (size-1);
  Printf.bprintf buf "input [%d:0] b;" (size-1);
  Printf.bprintf buf "output [%d:0] out;" (size-1);
  for j = 0 to size - 1 
  do Printf.bprintf buf "out<%d> = a<%d> & b<%d>;" j j j done;
  parse (Buffer.contents buf)

let module_or size = 
  let buf = Buffer.create 100 in
  Printf.bprintf buf "input [%d:0] a;" (size-1);
  Printf.bprintf buf "input [%d:0] b;" (size-1);
  Printf.bprintf buf "output [%d:0] out;" (size-1);
  for j = 0 to size - 1 
  do Printf.bprintf buf "out<%d> = a<%d> | b<%d>;" j j j done;
  parse (Buffer.contents buf)

let module_resize size_in size_out = 
  let buf = Buffer.create 100 in
  Printf.bprintf buf "input [%d:0] a;" (size_in-1);
  Printf.bprintf buf "output [%d:0] out;" (size_out-1);
  for j = 0 to min (size_in - 1) (size_out - 1)
  do Printf.bprintf buf "out<%d> = a<%d>;" j j done;
  if size_out > size_in 
  then 
    for j = size_in to size_out - 1
    do Printf.bprintf buf "out<%d> = 0;" j done;
  parse (Buffer.contents buf)

let module_resize_1 size_out = 
  let buf = Buffer.create 100 in
  Printf.bprintf buf "input a;";
  Printf.bprintf buf "output [%d:0] out;" (size_out-1);
  Printf.bprintf buf "out<0> = a;";
  for j = 1 to size_out - 1
  do Printf.bprintf buf "out<%d> = 0;" j done;
  parse (Buffer.contents buf)



let main = 
  make "adder" ["size",Int(4)] (fun f ->  let Int i = f "size" in adder (i-1))

  
