open ParametricModule

let env = add_module empty_env "add3" (Adder.adder 3)
let env = add_module env "and3" (Adder.module_and 3)
let env = add_module env "resize1_3" (Adder.module_resize_1 3)

let aag = parse_module env "
input player_1_i;
input player_2_i;
reg [2:0] transmitted_1;
reg [2:0] transmitted_2;
reg [2:0] energy_used_1;
reg [2:0] energy_used_2;

trans1 = player_1_i & (! (energy_used_1<0> & energy_used_1<1> & !energy_used_1<2>) );
trans2 = player_2_i & (! (energy_used_2<0> & energy_used_2<1> & !energy_used_2<2>) );

resize1_3(a=trans1, out=w1);
resize1_3(a=trans2, out=w2);

add3(a=energy_used_1 , b=w1 , s=new_energy1);
add3(a=energy_used_2 , b=w2 , s=new_energy2);

success1 = trans1 & (! trans2);
success2 = trans2 & (! trans1);

resize1_3(a=success1, out=x1);
resize1_3(a=success2, out=x2);

add3(a=transmitted_1 , b=x1 , s=new_trans1);
add3(a=transmitted_2 , b=x2 , s=new_trans2);

energy_used_1 <- new_energy1;
energy_used_2 <- new_energy2;
transmitted_1 <- new_trans1;
transmitted_2 <- new_trans2;

"

let main = make "medium_access" [] (fun f -> aag)
