let aag nb size =
  let buf = Buffer.create 100 in
  for i = 1 to nb do
    Printf.bprintf buf "input player_%d_i;\n" i;
    Printf.bprintf buf "reg [%d:0] pow%d;\n" (size - 1) i;
  done;
  for i = 1 to nb do
    Printf.bprintf buf "resize[size_in=1,size_out=%d](a=player_%d_i, out=w%d);\n" size i i;
    Printf.bprintf buf "adder[size=%d](a=pow%d , b=w%d , out=next_pow%d);\n" size i i i;
  done;
  for i = 1 to nb do
    for k = 0 to size - 1 do
      Printf.bpritnf buf "pow%d<%d> <- next_pow%d<%d>;\n" i k i k
    done;
  done;
  Buffer.contents buf


let payoff = 
  let m = 2 in
  let log_m = 3 in
  let log_max_payoff = 10 in
  let rec aux pow1 pow2 pow3 pow4 pow5 pow6 = 
    let [p1;p2;p3;p4;p5;p6] = List.map float_of_int [pow1;pow2;pow3;pow4;pow5;pow6] in
    let p = 1000. *. (1. -. exp (-0.5 *. p1 /. (p1 +. p2 +. p3 +. p4 +. p5 +. p6))) in
    int_of_float p
  in 
  let buf = Buffer.create 200 in
  Printf.bprintf buf "%s" (aag 6 2);
  Printf.bprintf buf "output [%d:0] payoff1;\n" (log_max_payoff-1);
  Printf.bprintf buf "output [%d:0] payoff2;\n" (log_max_payoff-1);
  Printf.bprintf buf "output [%d:0] payoff3;\n" (log_max_payoff-1);

  for pow1 = 0 to m do
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow1,out=pow1_equal_%d);\n" log_m pow1 pow1;
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow2,out=pow2_equal_%d);\n" log_m pow1 pow1;
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow3,out=pow3_equal_%d);\n" log_m pow1 pow1;
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow4,out=pow4_equal_%d);\n" log_m pow1 pow1;
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow5,out=pow5_equal_%d);\n" log_m pow1 pow1;
    Printf.bprintf buf "equal[size=%d,value=%d](a=pow6,out=pow6_equal_%d);\n" log_m pow1 pow1;
  done;
  for pow1 = 0 to m do
    for pow2 = 0 to m do
      for pow3 = 0 to m do
      for pow4 = 0 to m do
      for pow5 = 0 to m do
      for pow6 = 0 to m do
	Printf.bprintf buf "cond_%d_%d_%d_%d_%d_%d = pow1_equal_%d & pow2_equal_%d & pow3_equal_%d & pow4_equal_%d & pow5_equal_%d & pow6_equal_%d;\n" pow1 pow2 pow3 pow4 pow5 pow6;
	let payoff = aux pow1 pow2 pow3 pow4 pow5 pow6 in
	Printf.bprintf buf "assign[size=%d,value=%d](out=value_%d_%d_%d_%d_%d_%d);\n" log_max_payoff payoff pow1 pow2 pow3 pow4 pow5 pow6;
      done;
      done;
      done;
      done;
    done;
  done;
  let nb = ((m+1)*(m+1)*(m+1)*(m+1)*(m+1)*(m+1)) in

  Printf.bprintf buf "switch[nb=%d,size=%d](out=next_payoff1" nb log_max_payoff;
  let index= ref 0 in
  for pow1 = 0 to m do
    for pow2 = 0 to m do
      for pow3 = 0 to m do
	Printf.bprintf buf ",case%d=cond_%d_%d_%d,then%d=value_%d_%d_%d" !index pow1 pow2 pow3 !index pow1 pow2 pow3 ;
	incr index
      done;
    done;
  done;
  Printf.bprintf buf ");\n";
  for i = 0 to log_max_payoff - 1 do
    Printf.bprintf buf "payoff1<%d> = next_payoff1<%d>;\n" i i;
  done;


  Printf.bprintf buf "switch[nb=%d,size=%d](out=next_payoff2" nb log_max_payoff;
  let index= ref 0 in
  for pow1 = 0 to m do
    for pow2 = 0 to m do
      for pow3 = 0 to m do
	Printf.bprintf buf ",case%d=cond_%d_%d_%d,then%d=value_%d_%d_%d" !index pow1 pow2 pow3 !index pow2 pow1 pow3 ;
	incr index
      done;
    done;
  done;
  Printf.bprintf buf ");\n";
  for i = 0 to log_max_payoff - 1 do
    Printf.bprintf buf "payoff2<%d> = next_payoff2<%d>;\n" i i;
  done;


  Printf.bprintf buf "switch[nb=%d,size=%d](out=next_payoff3" nb log_max_payoff;
  let index= ref 0 in
  for pow1 = 0 to m do
    for pow2 = 0 to m do
      for pow3 = 0 to m do
	Printf.bprintf buf ",case%d=cond_%d_%d_%d,then%d=value_%d_%d_%d" !index pow1 pow2 pow3 !index pow3 pow2 pow1 ;
	incr index
      done;
    done;
  done;
  Printf.bprintf buf ");\n";
  for i = 0 to log_max_payoff - 1 do
    Printf.bprintf buf "payoff3<%d> = next_payoff3<%d>;\n" i i;
  done;


  Buffer.contents buf

  
let main = 
  print_endline payoff
