let _ = Common.display_debug := true


let winning_region game controllables uncontrollables j_list_env j_list_sys = 
  let cox x = 			  
    print_endline "cox";
    Attractor.trap game controllables uncontrollables x 
  in

  (* tables to store intermediary results *)
  let mem_x = Hashtbl.create ((List.length j_list_env) *(List.length j_list_sys)) in
  let mem_y = Hashtbl.create (List.length j_list_env) in

  let z = AigerBdd.fixpoint
    (fun z ->
      print_endline "fixpoint z";
      (* mem.clear(); *)
      let size_j_sys, z =
	List.fold_left
	  (fun (j,z) j_sys ->
	    j+1,
	    AigerBdd.fixpoint 
	      (fun y ->
		print_endline "fixpoint y";
		let start = Cudd.bddOr (cox y) (Cudd.bddAnd (j_sys) (cox z)) in
		let size_j_env, y = 
		  List.fold_left
		    (fun (i,y) j_env ->
		      let x = AigerBdd.fixpoint
			(fun x ->
			  print_endline "fixpoint x";
			  let cx = cox x in
			  print_endline "cox computed";
			  Cudd.bddOr start (Cudd.bddAnd (Cudd.bddNot j_env) cx) 
			) z 
		      in
		      print_endline "x computed";
		      Hashtbl.add mem_x (j,i) x;
		      (i+1,Cudd.bddOr y x)
		    ) (0,Cudd.bddFalse()) j_list_env
		in
		Hashtbl.add mem_y j y; 
		y
	      ) (Cudd.bddFalse ())
	  ) (0,z) j_list_sys
      in z
    ) (Cudd.bddTrue ())

  in z


let test aiger ass gua =
  Cudd.init 100;
  let string_to_bdd s = 
    WeakMuller.AtomicFormula.to_bdd 
      (fun t -> Aiger.name_to_literals aiger t)
      (WeakMuller.AtomicFormula.of_string s)
  in
  let ass_bdd = List.map string_to_bdd ass in
  let gua_bdd = List.map string_to_bdd gua in
  let contr,uncontr = Attractor.controllables aiger in
  Printf.printf "File %s: %d inputs, %d latches\n" Sys.argv.(1) aiger.num_inputs aiger.num_latches;
  Cudd.init (aiger.num_inputs+2*aiger.num_latches+2);
  let initial = AigerBdd.initial_state aiger in
  let precomputation = AigerBdd.of_aiger aiger in   
  print_endline "precomputation computed";
  let win = winning_region precomputation contr uncontr ass_bdd gua_bdd in
  let initial_winning = Cudd.bddRestrict win initial in

  if Cudd.value initial_winning = 1 
  then print_endline "realizable"
  else if Cudd.value initial_winning = 0
  then print_endline "unrealizable"
  else (Cudd.dumpDot ("problem_report.out") initial_winning;  print_endline "problem...")


let main =
  if Filename.check_suffix Sys.argv.(0) "generalizedReactivity" 
  then 
    if Array.length Sys.argv < 4
    then Printf.printf "usage : %s <file> assumption guarantee\n" Sys.argv.(0)
    else 
      let aiger = Aiger.read_from_file Sys.argv.(1) in
      test aiger [Sys.argv.(2)] [Sys.argv.(3)]
