(** Type of regular expressions *)
type t

(** The grammar for regular expression is given by : 
r ::= r | r ; r & r ; r* ; r r; (r); { p }; r+ ; r?; .
p ::= p | p ; p & p ; !p ; (p); ident ; true
*)

val of_string : string -> t

val alt : t -> t -> t
val concat : t -> t -> t
val star : t -> t

module Proposition : 
sig
  type t
end

module PropMap : Map.S with type key = Proposition.t

val residuals : t -> t PropMap.t

(** [module_regexp expr] *)
val module_regexp : string -> Aiger.t

(** Contains the modules of SpeculogModules and a module [regexp] *)
val env : Environment.env

val test : string -> unit
