
let to_aig file_name =
  let input_file = open_in file_name in
  let buffer = Buffer.create 200 in
  let rec read () = 
    try 
      let line = input_line input_file in
      Buffer.add_string buffer line;
      Buffer.add_char buffer '\n';
      read ()
    with End_of_file -> ()
  in
  read ();
  close_in input_file;
  SpeculogParser.parse_module SpeculogModules.env (Buffer.contents buffer) 

let test file_name =
  let aiger = to_aig file_name in 
  Aiger.write aiger stdout

    
let main = 
  if Filename.basename Sys.argv.(0) = "speculog" 
  || Filename.basename Sys.argv.(0) = "speculogCudd" 
    || Filename.basename Sys.argv.(0) = "speculog.byte" 
  then   
    if Array.length Sys.argv < 2
    then Printf.printf "usage : %s speculog_file\n" Sys.argv.(0)
    else test Sys.argv.(1)
  

