(** General translation from multiplayer game to two-player game. 
    In the deviator game, the controller and the environment
    chose a an action. The next state follows from the action of 
    the environment, suspects are those whose action differ 
    in the choice of the controller and of the environment.
*)

type t = {
  aiger:Aiger.t; 
  players:Coalition.t;
  controller:Aiger.lit -> Coalition.Player.t;
}

val add_player : t -> Coalition.Player.t -> t

val of_aiger : Aiger.t -> t
val read_from_file : string -> t

(** Return the deviator game and the list of controllable 
    and uncontrollable literals.
    In the game controller should decide on its action first.
*)
val deviator_game : t -> (Aiger.t * Aiger.lit list * Aiger.lit list)

val deviator : Coalition.Player.t -> string

val test : string -> unit
