(* The payoff of a player is defined by such a list. 
   The payoff of the player is the maximal index whose 
   associated formula is satisfied.
*)

(*
type payoff = (WeakMuller.Formula.t * int) list

val read_payoff : in_channel -> payoff
*)
type player = Coalition.Player.t

(* module Coalition : Set.S with type elt = player *)

(*val coalition_to_string : Coalition.t -> string*)

module PlayerMap : Map.S with type key = player

(*
type payoff_definition = payoff PlayerMap.t

val read_payoff_definition : in_channel -> payoff_definition

val read_payoff_file : string -> payoff_definition


type payoff_vector = int PlayerMap.t

val payoff_vector_to_string : payoff_vector -> string

val possible_payoffs : payoff_definition -> payoff_vector list
*)
(*
type comparison = Smaller | SmallerEq | Equal | GreaterEq | Greater

val compare_to_weak_Muller : payoff_definition -> (player*comparison*int) -> WeakMuller.Formula.t
*)
type payoff_formula = 
| PF_not of payoff_formula
| PF_and of payoff_formula * payoff_formula
| PF_or of payoff_formula * payoff_formula
| PF_eventually of StateFormula.t
| PF_always of StateFormula.t
(*| PF_compare of player * comparison * int*)

val payoff_formula_to_string : payoff_formula -> string

type formula = (Coalition.t * payoff_formula) list

val parse_formula : string -> formula

val formula_to_string : formula -> string

(* val players : Aiger.t -> Coalition.t*)


exception TrivialFormula of bool

val formula_to_weak_Muller : Coalition.t -> formula -> WeakMuller.Formula.t

(** Returns the deviator game and the winning region for 
    the given payoff definition and formula. *)
val equilibria_region : Translation.t -> Coalition.t -> formula -> (Aiger.t * Attractor.t)
